/*
POS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package posapi

import (
	"encoding/json"
)

// checks if the AddReceiptWebhook type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AddReceiptWebhook{}

// AddReceiptWebhook struct for AddReceiptWebhook
type AddReceiptWebhook struct {
	TransactionId string `json:"transaction_id"`
	ChannelId string `json:"channel_id"`
	ConversationId string `json:"conversation_id"`
	ContactId string `json:"contact_id"`
	Attributes map[string]interface{} `json:"attributes,omitempty"`
	Receipt AddReceiptWebhookReceipt `json:"receipt"`
}

// NewAddReceiptWebhook instantiates a new AddReceiptWebhook object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAddReceiptWebhook(transactionId string, channelId string, conversationId string, contactId string, receipt AddReceiptWebhookReceipt) *AddReceiptWebhook {
	this := AddReceiptWebhook{}
	this.TransactionId = transactionId
	this.ChannelId = channelId
	this.ConversationId = conversationId
	this.ContactId = contactId
	this.Receipt = receipt
	return &this
}

// NewAddReceiptWebhookWithDefaults instantiates a new AddReceiptWebhook object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAddReceiptWebhookWithDefaults() *AddReceiptWebhook {
	this := AddReceiptWebhook{}
	return &this
}

// GetTransactionId returns the TransactionId field value
func (o *AddReceiptWebhook) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhook) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *AddReceiptWebhook) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetChannelId returns the ChannelId field value
func (o *AddReceiptWebhook) GetChannelId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ChannelId
}

// GetChannelIdOk returns a tuple with the ChannelId field value
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhook) GetChannelIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ChannelId, true
}

// SetChannelId sets field value
func (o *AddReceiptWebhook) SetChannelId(v string) {
	o.ChannelId = v
}

// GetConversationId returns the ConversationId field value
func (o *AddReceiptWebhook) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhook) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *AddReceiptWebhook) SetConversationId(v string) {
	o.ConversationId = v
}

// GetContactId returns the ContactId field value
func (o *AddReceiptWebhook) GetContactId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ContactId
}

// GetContactIdOk returns a tuple with the ContactId field value
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhook) GetContactIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ContactId, true
}

// SetContactId sets field value
func (o *AddReceiptWebhook) SetContactId(v string) {
	o.ContactId = v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *AddReceiptWebhook) GetAttributes() map[string]interface{} {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string]interface{}
		return ret
	}
	return o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhook) GetAttributesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.Attributes) {
		return map[string]interface{}{}, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *AddReceiptWebhook) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string]interface{} and assigns it to the Attributes field.
func (o *AddReceiptWebhook) SetAttributes(v map[string]interface{}) {
	o.Attributes = v
}

// GetReceipt returns the Receipt field value
func (o *AddReceiptWebhook) GetReceipt() AddReceiptWebhookReceipt {
	if o == nil {
		var ret AddReceiptWebhookReceipt
		return ret
	}

	return o.Receipt
}

// GetReceiptOk returns a tuple with the Receipt field value
// and a boolean to check if the value has been set.
func (o *AddReceiptWebhook) GetReceiptOk() (*AddReceiptWebhookReceipt, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Receipt, true
}

// SetReceipt sets field value
func (o *AddReceiptWebhook) SetReceipt(v AddReceiptWebhookReceipt) {
	o.Receipt = v
}

func (o AddReceiptWebhook) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AddReceiptWebhook) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["transaction_id"] = o.TransactionId
	toSerialize["channel_id"] = o.ChannelId
	toSerialize["conversation_id"] = o.ConversationId
	toSerialize["contact_id"] = o.ContactId
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	toSerialize["receipt"] = o.Receipt
	return toSerialize, nil
}

type NullableAddReceiptWebhook struct {
	value *AddReceiptWebhook
	isSet bool
}

func (v NullableAddReceiptWebhook) Get() *AddReceiptWebhook {
	return v.value
}

func (v *NullableAddReceiptWebhook) Set(val *AddReceiptWebhook) {
	v.value = val
	v.isSet = true
}

func (v NullableAddReceiptWebhook) IsSet() bool {
	return v.isSet
}

func (v *NullableAddReceiptWebhook) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAddReceiptWebhook(val *AddReceiptWebhook) *NullableAddReceiptWebhook {
	return &NullableAddReceiptWebhook{value: val, isSet: true}
}

func (v NullableAddReceiptWebhook) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAddReceiptWebhook) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


